
  MEMBER

_ABCDllMode_  EQUATE(0)
_ABCLinkMode_ EQUATE(1)

  MAP
  .

  INCLUDE('ViewLoc.inc'),ONCE
  INCLUDE('Keycodes.clw'),ONCE

ViewEntryLocator.TakeAccepted PROCEDURE
! override the TakeAccepted and call te ResetFromBuffer method
! instead of the Reset(x) method

  code

  update(Self.Control)
  Self.FreeElement = Self.Shadow
  IF Self.FreeElement
    Self.ViewManager.ResetFromBuffer()
    select(Self.ViewManager.ListControl)
  end

  return(false)     ! always return false, the locate action was handled here
! TakeAccepted ------------------------------------------------------------------------------

ViewIncrementalLocator.TakeKey PROCEDURE
! override the TakeKey method,
! this method uses the ResetFromBuffer method to position the browse.
! the code was taken from the parent TakeKey method, the diffrence is the
! ResetFromBuffer method is called instead of the Reset(x) method

Key             BYTE,AUTO
UpdateNeeded    byte(false)     ! flag to indicate if locator control changed
ShadowLength    unsigned,auto   ! length of the shadow field

  code

  Key = KEYCHAR()
  ShadowLength = len(Self.Shadow)
  IF KEYCODE() = BSKey
    IF ShadowLength
      SELF.Shadow = SELF.Shadow[1: ShadowLength - 1]
    END
    SELF.Update
    UpdateNeeded = true
  ELSIF KEYCODE() = SpaceKey OR Key
    ! test for needed case
    case Self.NoCase
      of 0 ! default just move the value
        Self.Shadow = Self.Shadow & chr(key)
      of 1 ! upper case  move the upper case value
        Self.Shadow = Self.Shadow & upper(chr(key))
      of 2 ! captilize if length 0, or if last char a space, assumes Lastname, Firstname
           ! move the upper value else just move the value
        if (ShadowLength = 0) or (Self.Shadow[ShadowLength] = ' ')
          Self.Shadow = Self.Shadow & upper(chr(key))
        else
          Self.Shadow = Self.Shadow & chr(key)
        end ! if (ShadowLength = 0)
    end ! end case Self.NoCase
    SELF.Update
    UpdateNeeded = true 
  END

  if (UpdateNeeded)
    Self.ViewManager.ResetFromBuffer()
  end

  return(false)     ! always return false
! TakeKey -----------------------------------------------------------------------------------
